﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinTree;

namespace WinGridDropDownTree
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			for (int i = 0; i < 10; i++)
			{
				var node = ultraTree1.Nodes.Add("Node " + i.ToString());
				for (int j = 0; j < 5; j++)
				{
					node.Nodes.Add(node.Key + "/Node " + j.ToString(), "Node " + j.ToString());
				}
			}
		}

		private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
		{
			e.Layout.Bands[0].Columns[1].EditorComponent = ultraTextEditor1;
		}

		private void ultraTextEditor1_EditorButtonClick(object sender, EditorButtonEventArgs e)
		{
			if (ultraGrid1.ActiveCell.Text != "")
			{
				var pathArray = ultraGrid1.ActiveCell.Text.Split('/');

				int currentLevel = 0;
				SetSelectedNode(pathArray[currentLevel], pathArray, currentLevel, ultraTree1.Nodes);
			}
		}

		private void SetSelectedNode(string p, string[] pathArray, int currentLevel, TreeNodesCollection treeNodesCollection)
		{
			for (int i = 0; i < treeNodesCollection.Count; i++)
			{
				var node = treeNodesCollection[i];
				if (node.Text == p)
				{
					if (currentLevel == (pathArray.Length - 1))
					{
						ultraTree1.EventManager.SetEnabled(TreeEventIds.AfterSelect, false);
						node.Selected = true;
						ultraTree1.EventManager.SetEnabled(TreeEventIds.AfterSelect, true);
					}
					else
					{
						currentLevel++;
						SetSelectedNode(pathArray[currentLevel], pathArray, currentLevel, node.Nodes);
					}
					break;
				}
			}
		}

		private void ultraTree1_AfterSelect(object sender, SelectEventArgs e)
		{
		}

		private string GetNodePath(UltraTreeNode ultraTreeNode)
		{
			if (ultraTreeNode.Parent == null)
			{
				return ultraTreeNode.Text;
			}
			else
			{
				return (GetNodePath(ultraTreeNode.Parent) + "/" + ultraTreeNode.Text);
			}
		}

		private void ultraTree1_MouseUp(object sender, MouseEventArgs e)
		{
			if (ultraTree1.SelectedNodes.Count > 0)
			{
				string nodePath = GetNodePath(ultraTree1.SelectedNodes[0]);
				ultraGrid1.ActiveCell.Value = nodePath;
				ultraTextEditor1.CloseEditorButtonDropDowns();
			}
		}
	}
}
